; ZADANIE c.2
; Vytvorte program, ktory nacita z textoveho suboru postupnost celych cisel
; (viac ako 5) so znamienkom v desiatkovej ciselnej sustave. Precitane
; cisla transformujte na cisla v dvojkovej ciselnej sustave v doplnkovom
; kode, potom ich usporiadajte a vykonajte iba jednu z uvedench uloh:
;
;   1- vypocitajte sucet cisel
;
; Vysledky vypiste na obrazovku a ulozte do noveho textoveho suboru
;
; Na pracu so subormi mozete pouzit napr. sluzby 3dH, 3eH, 3fH,40H.
; Zvazte taky rozsah nacitanych cisel, aby ich bolo mozne spracovat
; v dostupnych registroch. Osetrite pripadne stavy presiahnutia pripustneho
; ciselneho rozsahu.
;
;--------------------------------------------------------------------------
; 
; Autor: Matej S~ustr
; Termin odovzdania: 25.11.2003
; 3. rocnik, kruzok SI-4
; sk. rok 2003/2004
;
;--------------------------------------------------------------------------
;
; Kompilacia:
;   tasm /ml /m5 /z /zi zad2.asm
;   tlink /x /n zad2
;
;**************************************************************************



model huge
.8086

.stack	64			;na zaciatok nam staci maly zasobnik

BUFSIZ 	equ 64

.data?
xcislo	db BUFSIZ dup(?)	;cisla ako ASCII - buffer na nacitanie
xcislo_	db ?
xcislo_end	equ offset xcislo_ - 1

sucetlo	dw ?			;sucet cisel
sucethi	dw ?			;horna cast suctu cisel (moze byt max. 9)

maxpoc	dw ?
pole_s	dw ?

hfile	dw ?			;handle suborov

.data
zaporne	db 0
eof	db 0			;priznak, ze uz je koniec suboru
boloc	db 0
cisel	dw 0

SUBIN	equ 'zad2.in'		;meno vstupneho suboru
SUBOUT	equ 'zad2.out'		;meno vystupneho suboru

subin	db SUBIN,0
subout	db SUBOUT,0

t_otv1	db 'Otvaram vstupny subor "',SUBIN,'"...$'
t_ok	db 'OK.'
t_nl	db 13,10,'$'		;newline
t_space	db ' $'

t_ferrf	db 'Subor nenajdeny!',13,10,'$'
t_ferrp	db 'Cesta nenajdena!',13,10,'$'
t_ferrh	db 'Nie je k dispozicii ziadny file handle!',13,10,'$'
t_ferra	db 'Pristup zamietnuty!',13,10,'$'
t_ferrm	db 'Neplatny mod pre otvorenie!',13,10,'$'
t_ferr	db 'Nejaka divna chyba!',13,10,'$'

t_alok	db 'Alokujem pamat...$'
t_malo	db 'Nedostatok pamate pre 6 alebo viac cisel!',13,10,'$'

t_citam	db 'Citam cisla do pamate...$'
t_badc1	db 13,10,"Neplatna cislica '$"
t_badc2	db "' - ignorujem ju a povazujem za oddelovac...$"
t_bigc	db 13,10,'Jedno zo vstup. cisel je prilis velke - koncim...$'
t_full	db 'Pamat je uz plna, viac necitam!',13,10,'$'

t_zat1	db 13,10,'Zatvaram vstupny subor "',SUBIN,'"...$'
t_err	db 'Chyba!',13,10,'$'

t_nzotr	db 13,10,'Nezotriedene cisla su:',13,10,'$'

t_tried	db 13,10,'Triedim...$'
t_zotr	db 'Zotriedene cisla su:',13,10,'$'

t_vypoc	db 13,10,'Vypocitavam sucet...$'
t_ovf	db 'Sucet pretiekol mimo rozsah!',13,10,'$'
t_vysl	db 'Vysledok je:$'

t_otv2	db 13,10,'Otvaram vystupny subor "',SUBOUT,'"...$'
t_zapis	db 'Zapisujem...$'
t_zat2	db 'Zatvaram vystupny subor "',SUBOUT,'"...$'

t_kon	db 13,10,'Koniec, vsetko OK!',13,10,'$'


;*** funkcie & makra ******************************************************
.code

;*** vypis na obrazovku je casto pouzivany, pre prehladnost ako makro...
VYPIS1 	macro txt
	mov	ah, 09
	mov	dx, offset txt
	int	21h
endm
VYPISx	macro txt		;ak je viac vypisov za sebou, netreba ah=09
	mov	dx, offset txt
	int	21h
endm

;--- otvaranie suboru -----------------------------------------------------
READONLY_C	equ 00h			;citanie v mode kompatib. s DOS 2
WRITEONLY_C	equ 01h			;zapis v kompatib.mode

fopen proc
;* v DS:DX musi byt adresa nazvu suboru, v AL mod na otvorenie

	mov	ah, 3dh
	int	21h
	jnc	fo_ok			;ak ok, ret
fo_chyba:
	cmp	ax, 2			;File not found
	mov	dx, offset t_ferrf
	je	fo_pischybu
	cmp	ax, 3			;Path not found
	mov	dx, offset t_ferrp
	je	fo_pischybu
	cmp	ax, 4			;No handle available
	mov	dx, offset t_ferrh
	je	fo_pischybu
	cmp	ax, 5			;Access denied
	mov	dx, offset t_ferra
	je	fo_pischybu
	cmp	ax, 12			;Open mode invalid
	mov	dx, offset t_ferrm
	je	fo_pischybu
	mov	dx, offset t_ferr	;ina divna chyba
fo_pischybu:
	mov	ah, 09h
	int	21h			;vypise chybu
	stc				;nastavi CF (po int21 moze byt 0)
fo_ok:
	ret
fopen endp


fcreate proc
;* vyuziva kontrolu chyb funkcie fopen

	mov	ah, 3ch
	xor	cx, cx			;Normal atribut
	int	21h
	jc	fo_chyba		;vypis chyby je vyssie
	ret				;vrati handle v ax
fcreate endp


;--- vypis cisla so znamienkom na obrazovku -------------------------------
vypisznam proc
;* vypise cislo CX:BX so znamienkom na obrazovku
	push	ds
	push	es

	mov	ax, @data
	mov	ds, ax
	mov	es, ax
	mov	di, offset xcislo_end
	mov	dx, cx
	xor	cx, cx
	cmp	dx, 0		;skontrolujeme, ci je vysledok zaporny
	jnl	kladne
	inc	cl		;indikacia zaporneho cisla
	not	dx
	neg	bx
kladne:
	mov	ax, bx		;v BX bola spodna cast
	xor	bh, bh
	mov	bl, 10		;budeme delit 10
convert_loop:
	div	bx
	add	dl, '0'		;chceme zvysok
	mov	[di], dl	;ulozime
	dec	di		;ukladame odzadu
	xor	dx, dx		;a zmazeme, nech sa da dalej delit
	test	ax, ax
	jnz	convert_loop	;ak este nie je 0, pokracujeme

	jcxz	uztovypis
	mov	al, '-'		;ak cislo bolo zaporne, pouzijeme -
	std
	stosb
	cld
uztovypis:
	inc	di
	mov	dx, di	
	mov	al, '$'		;aby sme mohli pouzit sluzbu 09h
	mov	[xcislo_], al	
	mov	ah, 09h
	int	21h

	pop	es
	pop	ds
	ret
vypisznam endp

;*** hl.program ***********************************************************
start:
	mov	ax, @data
	mov	ds, ax
;--- otvorenie, alokacia --------------------------------------------------
	VYPIS1	t_otv1
	mov	dx, offset subin
	mov	al, READONLY_C
	call	fopen			;vnutri je vypis pripadnej chyby
	jnc	otv1ok
	jmp	quiterr			;ak bola chyba, koniec!
    otv1ok:
	mov	[hfile], ax		;odlozime si handle
	VYPIS1	t_ok

	VYPISx	t_alok
	mov	ah, 48h			;budeme alokovat pamat
	mov	bx, 0ffffh		;najprv zistime, kolko je volnej
	int	21h
	cmp	bx, 1			;je menej ako 1 paragraph volny?
	jae	dostpamate
malopamate:
	VYPIS1	t_malo
	jmp	quiterr
dostpamate:
	cmp	bx, 4096		;mozme najviac 4096*16=65536
	jbe	alokuj
	mov	bx, 4096
alokuj:
	mov	dx, bx
	mov	cl, 3
	shl	dx, cl			;cx=pocet alokovanych wordov
	mov	[maxpoc], dx
	mov	ah, 48h
	int	21h
	jnc	alok_ok
	VYPIS1	t_err			;neznama chyba pri alokovani
	jmp	quiterr
alok_ok:
	mov	[pole_s], ax		;ulozime alokovany segment
	mov	es, ax			;ciel (es:di)
	VYPIS1	t_ok

;--- nacitanie + konverzia ------------------------------------------------
	VYPISx	t_citam
	xor	di, di			;zacneme od zaciatku segmentu
	push	di
citaj_loop:
	xor	ax, ax
	mov	bx, [hfile]
	xor	ch, ch
	mov	cl, BUFSIZ		;budeme citat po niekolko byte
	mov	dx, offset xcislo	; ^(kvoli rychlosti nacitavania)
	mov	si, dx			;s tymto budeme pracovat
	mov	ah, 3fh	
	int	21h			;NACITA
	cmp	cx, ax
	je	nie_eof
	mov	cx, ax
	mov	[eof], 1		;uz je koniec suboru
    nie_eof:
	test	ax, ax
	jz	koniec_cisla		;koniec sub. => koniec cisla

conv_cislo:
	xor	bh, bh
	mov	bl, 10			;kvoli nasobeniu
conv_cislo_loop:
	jcxz	conv_cislo_endcheck	;zasobnik sa vycerpal...
	lodsb
	jmp	conv_cislo_loop_do
    conv_cislo_endcheck:
	inc	bh			;bh=1, nech viem, ze je uplny kon.
	cmp	[eof], 0;bh
	jne	koniec_cisla
	dec	bh			;bh=0
	jmp	citaj_loop		;inak nacitaj dalsi buffer
conv_cislo_loop_do:
	dec	cx
	cmp	al, '-'
	je	minus
	sub	al, '0'			;sub hned vyuzijem na porovnanie
	jb	koniec_cisla		;medzera, tabulator, enter
	cmp	al, 9
	ja	bad_input

	mov	[boloc], 1		;akoze bola aspon 1 cislica
	pop	dx			;ulozene cislo
	push	ax			;al=posledna nacitana cislica
	mov	ax, dx
	mul	bx
	test	dx, dx
	pop	dx
	jnz	cislo_velke
	xor	dh, dh
	add	ax, dx			;pripocitam tu cislicu
	push	ax			;uloz cislo
	jnc	conv_cislo_loop

cislo_velke:
	VYPIS1	t_bigc			;chybova hlaska
;	jmp	chyba_nacitania		;a predcasne ukoncenie
chyba_nacitania:
	VYPIS1	t_zat1			;hlaska o zatvarani vstup. suboru
	mov	ah, 3eh
	mov	bx, [hfile]
	int	21h			;zatvori
	jmp	quit

minus:
	pop	dx
	inc	[zaporne]
	push	dx
	test	dx, dx			;ak cislo=0, mozeme minus zobrat
	jz	conv_cislo_loop		;inak vyhlasime zly vstup
	dec	[zaporne]

bad_input:
	VYPIS1	t_badc1			;zaciatok hlasky
	mov	ah, 02h
	int	21h			;vypise zly znak
	VYPIS1	t_badc2			;koniec hlasky

koniec_cisla:
	pop	ax			;ulozene cislo
	xor	bl, bl
	cmp	[boloc], bl		;ak ziadne cislo nebolo (iba vadne
	jz	po_zapise		; znaky, neukladaj 0 do pamate)

	cmp	[zaporne], bl
	jz	je_kladne		;nie je zaporne
	cmp	ax, 8000h		;pri zapornych mozu byt az do
	ja	cislo_velke		;(-)32768
	neg	ax
	jmp	zapis_cislo
je_kladne:
	test	ax, 8000h		;najvyssi bit uz je?
	jnz	cislo_velke		;cize je >32767, teda > signed word
zapis_cislo:
	stosw
	inc	[cisel]
	mov	ax, [maxpoc]
	cmp	ax, [cisel]
	ja	po_zapise		;pretieklo?

	VYPIS1	t_full			;ak hej tak to napis
	jmp	zavri1			;a dalej nenaticavaj

po_zapise:
	xor	ax, ax
	cmp	bh, bl			;ak nie je uplny koniec, pokracuj
	jne	zavri1			;v nacitavani
	mov	[boloc], al		;vynulujeme priznak cislice
	mov	[zaporne], al		;a tiez zaporneho znamienka
	push	ax			;aby sme zacali dalsie cislo od 0
	jmp	conv_cislo		;kvoli dalekemu relativnemu skoku

zavri1:
	VYPIS1	t_zat1			;hlaska o zatvarani vstup. suboru
	mov	ah, 3eh
	mov	bx, [hfile]
	int	21h			;zatvori

;--- vypis nevytriedenych -------------------------------------------------
	VYPIS1	t_nzotr
	push	di
	mov	cx, [cisel]
	jcxz	konvypnzotr
	xor	si, si
vypisnzotr_loop:
	push	ds		;*tato cast je neefektivna, lebo bola
	push	es		;*pisana na poslednu chvilu
	push	cx

	push	es
	pop	ds			;DS = segment s datami
	lodsw
	cwd
	mov	cx, dx
	mov	bx, ax			;nasa funkcia chce CX:BX
	push	ds
	pop	es
	call	vypisznam

	pop	cx
	pop	es
	pop	ds
	VYPIS1	t_space
	loop	vypisnzotr_loop
konvypnzotr:
	pop	di

;--- triedenie ------------------------------------------------------------
tried:
	VYPIS1	t_tried
	cmp	di, 4			;menej ako 2 prvky nebudeme triedit
	jb	pocitaj
	push	ds
	push	es			;ES = segment s nacitanymi datami
	pop	ds			;pouzivame DS:SI
	dec	di
	dec	di
	mov	dx, di			;DX = posledny nacitany prvok
	cld
tried_loop_out:
	xor	si, si			;SI = prvy nacitany prvok
	lodsw
tried_loop_in:
	mov	bx, ax
	lodsw
	cmp	ax, bx			;porovnam 2 za sebou iduce prvky
	jge	tried_nevymen
	mov	di, si
	sub	di, 4			;idem nazad o 2 (lodsw posunul o 1)
	stosw				;zapisem najprv povodny druhy
	mov	ax, bx
	stosw				;potom povodny prvy (pamatam si ho)
tried_nevymen:
	cmp	si, dx
	jbe	tried_loop_in		;az do konca
	dec	dx
	dec	dx
	cmp	dx, 2
	jae	tried_loop_out		;bubblesort, o 1 prechod menej

	pop	ds			;DS nazad (aby slo vypisovat text)

;--- vypis vytriedenych ---------------------------------------------------
	VYPIS1	t_zotr
	mov	cx, [cisel]
	jcxz	pocitaj
	xor	si, si
vypiszotr_loop:
	push	ds		;*tato cast je neefektivna, lebo bola
	push	es		;*pisana na poslednu chvilu
	push	cx

	push	es
	pop	ds			;DS = segment s datami
	lodsw
	cwd
	mov	cx, dx
	mov	bx, ax			;nasa funkcia chce CX:BX
	push	ds
	pop	es
	call	vypisznam

	pop	cx
	pop	es
	pop	ds
	VYPIS1	t_space
	loop	vypiszotr_loop

;--- vypocet --------------------------------------------------------------
pocitaj:
	VYPIS1	t_vypoc
	xor	bx, bx			;dol.cast
	xor	dx, dx			;hor.cast
	mov	cx, [cisel]
	jcxz	vypis
	push	ds
	push	es			;ES = segment s nacitanymi datami
	pop	ds			;pouzivame DS:SI
	xor	si, si			;data zacinaju od 0
pocitaj_loop:
	lodsw
	cmp	ax, 0
	jl	plus_zaporne
	add	bx, ax
	jc	pocitaj_1viac		;pretieklo 16bit vrchom
	jmp	pocitaj_next
    plus_zaporne:
	neg	ax			;nech nam poriadne funguje CF
	sub	bx, ax
	jc	pocitaj_1menej		;pretieklo 16bit spodom
	cmp	dx, -10
	jne	pocitaj_next
	test	bx, bx			;pri h=-10 dol. cast nemoze byt = 0
	je	pocitaj_pretieklo
	jmp	pocitaj_next
  pocitaj_1menej:
	dec	dx
	cmp	dx, -10			;nemoze byt take nizke
	jl	pocitaj_pretieklo
	jne	pocitaj_next
	test	bx, bx			;pri h=-10 dol. cast nemoze byt = 0
	je	pocitaj_pretieklo
	jmp	pocitaj_next
  pocitaj_1viac:
	inc	dx
	cmp	dx, 10			;nemoze byt take vysoke
	jge	pocitaj_pretieklo
pocitaj_next:
	loop	pocitaj_loop	
	mov	cx, dx			;ulozime hornu cast (DX sa pouziva)

	pop	ds			;DS nazad
	jmp	vypis

pocitaj_pretieklo:
	pop	ds
	VYPIS1	t_ovf
	jmp	quiterr

;--- vypis vysledku -------------------------------------------------------
vypis:
	VYPIS1	t_vysl
	push	ds		;pole dat uz netreba, ale ES potrebujeme...
	pop	es		;...pouzit v povodnom dat. segmente
	call	vypisznam	;vypise CX:BX

;--- zapis do suboru ------------------------------------------------------
zapis:
	VYPIS1	t_otv2
	mov	dx, offset subout
	call	fcreate			;vnutri je vypis pripadnej chyby
	jnc	otv2ok
	jmp	quiterr			;ak bola chyba, koniec!
    otv2ok:
	mov	[hfile], ax		;odlozime si handle
	push	ax
	VYPIS1	t_ok

	VYPISx	t_zapis
	pop	bx			;handle
	mov	dx, di			;toto nam zostalo
	mov	cx, offset xcislo_
	sub	cx, dx			;pocet bytov na zapis
	mov	ah, 40h
	int	21h			;zapis
	jnc	zapisok

	VYPIS1	t_err
	jmp	zavri2
zapisok:
	VYPIS1	t_ok
	VYPISx	t_zat2	
zavri2:
	mov	ah, 3eh
	mov	bx, [hfile]
	int	21h			;zatvori

quit:
	VYPIS1	t_kon
	mov	ax, 4c00h
	int	21h
quiterr:
	mov	ax, 4c01h
	int	21h
end start



;**************************************************************************
;
; Zhodnotenie:
;
; Program je funkcny podla zadania, bol vypracovany v prostredi editora
; Notepad a da sa prelozit cez Turbo Assembler (pozri hlavicku).
;
; Vstupne cisla su obmedzene na rozsah -32768 az 32767 (lebo ich udrziavam
; ako 16-bitove cisla), ich maximalny pocet je obmedzeny pamatou, ktora sa
; podari naalokovat, najviac vsak 32768 cisel (1 segment).
; Ich celkovy sucet moze byt -655359 az 655359 a to z dovodu obmedzenia
; pri deleni, ktore som pouzil. Kedze delim DX:AX / 10(word), podiel moze
; byt najviac 65535 a preto taketo obmedzenie.
;
; Format vstupneho suboru je volny, akekolvek znaky ine ako cislo alebo '-'
; sa povazuju za oddelovac cisel, prakticka je medzera, tabulator, enter.
; Koniec suboru nie je potrebne nijak zvlast indikovat nijakym specialnym
; znakom, proste staci koniec suboru.
;
; Program vyuziva iba zakladne funkcie DOSu, takze by mal fungovat aj na
; starsich verziach DOSu, pre otvaranie suborov pouziva kompatibilne mody.
; Vyuziva instrukcie procesora 8086.
;
; Mozne vylepsenia:
; - optimalizovat priebezny vypis nezotriedenych nacitanych a zotriedenych
;   cisel, pretoze tento bol dorobeny na poslednu chvilu a vyuziva prilis
;   vela odkladania cisel segmentov do pamate (na stack)
; - prehladnejsi vypis
;
; Popis vlastnych pouzitych algoritmov:
; - nacitanie zo suboru robim pomocou buffera, ktory pri podteceni znovu
;   naplnim zo suboru
; - triedenie robim pomocou bubblesortu, kde pri kazdom prechode nacitavam
;   to iste cislo z pamate iba raz, cim je toto optimalizovane.
;   Quicksort som nepouzil z toho dovodu, ze pri najhorsom pripade pociat.
;   usporiadania potrebujem 2*pocet prvkov na zapamatanie si fronty, ktoru
;   by som musel spracovavat, a na to nemam dostatok pamate (potreboval by
;   som dalsie obmedzenia na velkost vstupu).
; - scitanie cisel robim 19.3 bitove (v skutocnosti 32-bit s obmedzenim),
;   pouzivam totiz 16bitov a navyse 10 nasobok toho
; - vypis cisla na obrazovku je taktiez takyto rozsireny, znamienko si
;   zapamatam zvlast a delim pomocou MUL, pretoze IMUL je znacne obmedzeny 
;
; Upozornenie na taktiky a finty, ktore pouzil tvorca programu:
; - pouzivam TASM notaciu .code/.data atd., pretoze je jednoduchsia ako
;   explicitne definovanie segmentov
; - vid. vyssie "Popis vlastnych pouzitych algoritmov"
;

;EOF